﻿using Infragistics.Documents.Excel;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ExcelTableStylingTest
{
    public partial class Form1 : Form
    {
        string fileName = "file.xlsx";
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            Workbook workbook = new Workbook(WorkbookFormat.Excel2007);

            Worksheet sheet = workbook.Sheets.Add("Sheet1", SheetType.Worksheet) as Worksheet;
            for(int i=2; i<9; i++)
            {
                WorksheetRow row = sheet.Rows[i];
                for(int j=2; j<9; j++)
                {
                    row.Cells[j].Value = r.Next(1000);
                    row.Cells[j].CellFormat.LeftBorderColorInfo = Color.Black;
                    row.Cells[j].CellFormat.LeftBorderStyle = CellBorderLineStyle.Thin;
                    row.Cells[j].CellFormat.BottomBorderColorInfo = Color.Black;
                    row.Cells[j].CellFormat.BottomBorderStyle = CellBorderLineStyle.Thin;
                }
            }

            var tableStyle = new WorksheetTableStyle("BR_Table");
            //Table Header
            tableStyle.AreaFormats[WorksheetTableStyleArea.HeaderRow].Fill = CellFill.CreateSolidFill(Color.Black);
            tableStyle.AreaFormats[WorksheetTableStyleArea.HeaderRow].Font.Bold = ExcelDefaultableBoolean.True;
            tableStyle.AreaFormats[WorksheetTableStyleArea.HeaderRow].Font.ColorInfo = new WorkbookColorInfo(Color.White);
            //Row and Alternating ROw
            tableStyle.AreaFormats[WorksheetTableStyleArea.RowStripe].Fill = CellFill.CreateSolidFill(Color.Transparent);
            tableStyle.AreaFormats[WorksheetTableStyleArea.AlternateRowStripe].Fill = CellFill.CreateSolidFill(Color.Transparent);            

            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].BottomBorderStyle = CellBorderLineStyle.Thin;
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].BottomBorderColorInfo = new WorkbookColorInfo(Color.Black);
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].TopBorderStyle = CellBorderLineStyle.Thin;
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].TopBorderColorInfo = new WorkbookColorInfo(Color.Black);
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].LeftBorderStyle = CellBorderLineStyle.Thin;
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].LeftBorderColorInfo = new WorkbookColorInfo(Color.Black);
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].RightBorderStyle = CellBorderLineStyle.Thin;
            tableStyle.AreaFormats[WorksheetTableStyleArea.WholeTable].RightBorderColorInfo = new WorkbookColorInfo(Color.Black);                        

            workbook.CustomTableStyles.Add(tableStyle);

            WorksheetTable table = sheet.Tables.Add("C3:I9", false, tableStyle);

            if (File.Exists(fileName))
            {
                File.Delete(fileName);
            }

            workbook.Save(fileName);

            Process.Start(fileName);
        }
    }
}
